#!/bin/sh
#aller.tcl
#\
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 David Lucardi <davidlucardi@aol.com>
#  Copyright (C) 2002 Andr Connes <andre.connes@toulouse.iufm.fr>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : aller.tcl
#  Author  : David Lucardi <davidlucardi@aol.com>
#  Modifier:
#  Date    : 24/04/2002
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    $Id: aller.tcl,v 1.4 2003/11/01 16:32:19 david Exp $
#  @author     David Lucardi
#  @modifier   
#  @project    Le terrier
#  @copyright  David Lucardi
#  @copyright  Andr Connes
# 
#***********************************************************************
global sysFont listappli nom listexo strtext basedir Homeconf plateforme
set plateforme $tcl_platform(platform)
set ident $tcl_platform(user)

source msg.tcl
source fonts.tcl
source path.tcl




init $plateforme
inithome
initlog $plateforme $ident

set f [open [file join $Homeconf reglages aller.conf] "r"]
set nom [gets $f]
close $f

wm geometry . +0+0
. configure -background #ffffff

proc interface {} {
global sysFont strtext listexo iwish progaide basedir plateforme

# Creation du menu utilise comme barre de menu:
catch {destroy .menu}
catch {destroy .wleft}
catch {destroy .wcenter}
catch {destroy .wright}

menu .menu -tearoff 0

# Creation du menu Fichier
menu .menu.fichier -tearoff 0
.menu add cascade -label [mc {Fichier}] -menu .menu.fichier
.menu.fichier add command -label [mc {Editeur}] -command "lanceappli editeur.tcl 1"
.menu.fichier add command -label [mc {Bilans}] -command "lanceappli bilan.tcl 1"
.menu.fichier add sep
.menu.fichier add command -label [mc {Quitter  Ctrl-Q}] -command exit

menu .menu.option -tearoff 0
.menu add cascade -label [mc {Options}] -menu .menu.option
.menu.option add command -label [mc {Reglages}] -command "source reglages.tcl"

menu .menu.option.repconf -tearoff 0 
.menu.option add cascade -label [mc {Dossier de travail}] -menu .menu.option.repconf
.menu.option.repconf add radio -label [mc {Commun}] -variable repertconf -value 1 -command "changeinterface"
.menu.option.repconf add radio -label [mc {Individuel}] -variable repertconf -value 0 -command "changeinterface"



#menu .menu.option.repwork -tearoff 0 
#.menu.option add cascade -label [mc {Fichiers de textes}] -menu .menu.option.repwork 
#.menu.option.repwork add radio -label [mc {Communs}] -variable reperttext -value 1 -command "changehome"
#.menu.option.repwork add radio -label [mc {Individuels}] -variable reperttext -value 0 -command "changehome"

#inithome


menu .menu.action -tearoff 0
.menu add cascade -label [mc {Activits}] -menu .menu.action
.menu.action add command -label [mc {Closure}] -command "lanceappli closure.tcl 1"
.menu.action add command -label [mc {Reconstitution}] -command "lanceappli reconstitution.tcl 1"
.menu.action add command -label [mc {Phrases melangees}] -command "lanceappli phrase.tcl 1"
.menu.action add command -label [mc {Mots melanges}] -command "lanceappli mots.tcl 1"
.menu.action add command -label [mc {Texte a corriger}] -command "lanceappli fautes.tcl 1"
.menu.action add command -label [mc {Phrases sans espaces}] -command "lanceappli espace.tcl 1"
.menu.action add command -label [mc {Phrases incompletes}] -command "lanceappli incomplet.tcl 1"
if {[string first "\$t tag add bisque1" $strtext]!=-1} {
.menu.action add command -label [lindex [lindex $listexo 0] 1] -command "lance 0"
}
if {[string first "\$t tag add bisque2" $strtext]!=-1} {
.menu.action add command -label [lindex [lindex $listexo 1] 1] -command "lance 1"
}
if {[string first "\$t tag add bisque3" $strtext]!=-1} {
.menu.action add command -label [lindex [lindex $listexo 2] 1] -command "lance 2"
}
if {[string first "\$t tag add bisque4" $strtext]!=-1} {
.menu.action add command -label [lindex [lindex $listexo 3] 1] -command "lance 3"
}

.menu.action add command -label [mc {Ponctuation 1}] -command "lanceappli ponctuation1.tcl 1"
.menu.action add command -label [mc {Ponctuation 2}] -command "lanceappli ponctuation2.tcl 1"

if {$plateforme == "windows"} {
.menu add command -label [mc {Utilisateur}] -command "setwindowsusername"
}


#.menu add command -label [mc {Aide}] -command "exec $iwish jouer.tcl aidealler.kdb"
set fichier [file join $basedir aide index.htm]
.menu add command -label [mc {Aide}] -command "exec $progaide \042$fichier\042 &"
. configure -menu .menu

#######################################################################"
. configure -background blue
frame .wleft -background blue -height 300 -width 200
pack .wleft -side left

label .wleft.labclosure -text [mc {Closure}] -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify left -foreground orange
pack .wleft.labclosure -side top -anchor w
bind .wleft.labclosure <1> "lanceappli closure.tcl 1"
bind .wleft.labclosure <Any-Enter> ".wleft.labclosure configure -foreground yellow"
bind .wleft.labclosure <Any-Leave> ".wleft.labclosure configure -foreground orange"

label .wleft.labreconstitution -text [mc {Reconstitution}] -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify left -foreground orange
pack .wleft.labreconstitution -side top -anchor w
bind .wleft.labreconstitution <1> "lanceappli reconstitution.tcl 1"
bind .wleft.labreconstitution <Any-Enter> ".wleft.labreconstitution configure -foreground yellow"
bind .wleft.labreconstitution <Any-Leave> ".wleft.labreconstitution configure -foreground orange"

label .wleft.labpmelang -text [mc {Phrases melangees}] -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify left -foreground orange
pack .wleft.labpmelang -side top -anchor w
bind .wleft.labpmelang <1> "lanceappli phrase.tcl 1"
bind .wleft.labpmelang <Any-Enter> ".wleft.labpmelang configure -foreground yellow"
bind .wleft.labpmelang <Any-Leave> ".wleft.labpmelang configure -foreground orange"

label .wleft.labmmelang -text [mc {Mots Melanges}] -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify left -foreground orange
pack .wleft.labmmelang -side top -anchor w
bind .wleft.labmmelang <1> "lanceappli mots.tcl 1"
bind .wleft.labmmelang <Any-Enter> ".wleft.labmmelang configure -foreground yellow"
bind .wleft.labmmelang <Any-Leave> ".wleft.labmmelang configure -foreground orange"

label .wleft.labtcorrig -text [mc {Texte a corriger}] -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify left -foreground orange
pack .wleft.labtcorrig -side top -anchor w
bind .wleft.labtcorrig <1> "lanceappli fautes.tcl 1"
bind .wleft.labtcorrig <Any-Enter> ".wleft.labtcorrig configure -foreground yellow"
bind .wleft.labtcorrig <Any-Leave> ".wleft.labtcorrig configure -foreground orange"

label .wleft.labespace -text [mc {Phrases sans espaces}] -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify left -foreground orange
pack .wleft.labespace -side top -anchor w
bind .wleft.labespace <1> "lanceappli espace.tcl 1"
bind .wleft.labespace <Any-Enter> ".wleft.labespace configure -foreground yellow"
bind .wleft.labespace <Any-Leave> ".wleft.labespace configure -foreground orange"

label .wleft.labpincomp -text [mc {Phrases incompletes}] -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify left -foreground orange
pack .wleft.labpincomp -side top -anchor w
bind .wleft.labpincomp <1> "lanceappli incomplet.tcl 1"
bind .wleft.labpincomp <Any-Enter> ".wleft.labpincomp configure -foreground yellow"
bind .wleft.labpincomp <Any-Leave> ".wleft.labpincomp configure -foreground orange"


frame .wcenter -background blue -height 300 -width 200
pack .wcenter -side left

frame .wright -background blue -height 300 -width 200
pack .wright -side left
if {[string first "\$t tag add bisque1" $strtext]!=-1} {
label .wright.labsup1 -text [lindex [lindex $listexo 0] 1]  -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify right -foreground orange
pack .wright.labsup1 -side top -anchor e
bind .wright.labsup1 <1> "lance 0"
bind .wright.labsup1 <Any-Enter> ".wright.labsup1 configure -foreground yellow"
bind .wright.labsup1 <Any-Leave> ".wright.labsup1 configure -foreground orange"
}
if {[string first "\$t tag add bisque2" $strtext]!=-1} {
label .wright.labsup2 -text [lindex [lindex $listexo 1] 1]  -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify right -foreground orange
pack .wright.labsup2 -side top -anchor e
bind .wright.labsup2 <1> "lance 1"
bind .wright.labsup2 <Any-Enter> ".wright.labsup2 configure -foreground yellow"
bind .wright.labsup2 <Any-Leave> ".wright.labsup2 configure -foreground orange"
}
if {[string first "\$t tag add bisque3" $strtext]!=-1} {
label .wright.labsup3 -text [lindex [lindex $listexo 2] 1]  -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify right -foreground orange
pack .wright.labsup3 -side top -anchor e
bind .wright.labsup3 <1> "lance 2"
bind .wright.labsup3 <Any-Enter> ".wright.labsup3 configure -foreground yellow"
bind .wright.labsup3 <Any-Leave> ".wright.labsup3 configure -foreground orange"
}
if {[string first "\$t tag add bisque4" $strtext]!=-1} {
label .wright.labsup4 -text [lindex [lindex $listexo 3] 1]  -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify right -foreground orange
pack .wright.labsup4 -side top -anchor e
bind .wright.labsup4 <1> "lance 3"
bind .wright.labsup4 <Any-Enter> ".wright.labsup4 configure -foreground yellow"
bind .wright.labsup4 <Any-Leave> ".wright.labsup4 configure -foreground orange"
}

label .wright.labponct1 -text [mc {Ponctuation 1}] -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify right -foreground orange
pack .wright.labponct1 -side top -anchor e
bind .wright.labponct1 <1> "lanceappli ponctuation1.tcl 1"
bind .wright.labponct1 <Any-Enter> ".wright.labponct1 configure -foreground yellow"
bind .wright.labponct1 <Any-Leave> ".wright.labponct1 configure -foreground orange"

label .wright.labponct2 -text [mc {Ponctuation 2}] -background blue -wraplength 180 -font $sysFont(t) -pady 10 -justify right -foreground orange
pack .wright.labponct2 -side top -anchor e
bind .wright.labponct2 <1> "lanceappli ponctuation2.tcl 1"
bind .wright.labponct2 <Any-Enter> ".wright.labponct2 configure -foreground yellow"
bind .wright.labponct2 <Any-Leave> ".wright.labponct2 configure -foreground orange"

set myimage [image create photo -file sysdata/background.gif]
label .wcenter.imagedisplayer -image $myimage -background blue
pack .wcenter.imagedisplayer -side top




#####################################################################"
}
#################
# Image de fond #
#################
############
# Bindings #
############
bind . <Control-q> {exit}




proc testebisque {nom} {
global sysFont listappli listexo strtext
set listexo {}

set strtext ""
   if {$nom != "none" && $nom != "" && $nom !=[mc {Aucun}]} {

   set f [open $nom]                 
       while {![eof $f]} {

       set strtext $strtext[read $f 10000]
       }
   close $f
set ind  [string first "set listexo" $strtext]
if {$ind == -1} {
return
}
eval [string range $strtext $ind end]

}
}


proc lanceappli {appli niveau} {
global iwish
set appli [file join $appli]
exec $iwish $appli $niveau &
}

proc changeinterface {} {
global nom Homeconf
changehome
set f [open [file join $Homeconf reglages aller.conf] "r"]
set nom [gets $f]
close $f
testebisque $nom
interface
}

proc lance {i} {
global sysFont listexo
 switch [lindex [lindex $listexo $i] 3] {
   1 {lanceappli reconnaitre.tcl [lindex [lindex $listexo $i] 0]}
   2 {lanceappli completer.tcl [lindex [lindex $listexo $i] 0]}
}
}

testebisque $nom
interface



