############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File    : editeur.tcl
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#!/bin/sh
#editeur.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $$$
#  Author  : davidlucardi@aol.com
#  Modifier: 
#  Date    : 
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     David Lucardi
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 
# 
#  *************************************************************************

source menus.tcl
source msg.tcl
source fonts.tcl
source path.tcl

global sysFont tableaumots tableauindices listexo

inithome

set bgn #ffff80
set bgl #ff80c0
set listexo { {bisque1 {Exercice 1} Consigne 1} {bisque2 {Exercice 2} Consigne 1} {bisque3 {Exercice 3} Consigne 1} {bisque4 {Exercice 4} Consigne 1}}

. configure -background black -width 640 -height 480
wm geometry . +0+0


#wm title . Bilan\040[lindex [split [lindex [split $file /] end] .] 0]
frame .menu -height 40
pack .menu -side top -fill both
frame .bframe -height 40
pack .bframe -side bottom -fill both

label .bframe.consigne
pack .bframe.consigne

text .text -yscrollcommand ".scroll set" -setgrid true -width 45 -height 15 -wrap word -background white -font $sysFont(l)
scrollbar .scroll -command ".text yview"
pack .scroll -side right -fill y
pack .text -expand yes -fill both

menu_frame .menu .text

focus .text

bind .text <ButtonRelease-1> "highlight"
bind .text <ButtonRelease-3> "lowlight"


proc tague {} {
global sysFont tableaumots str
    if {$str !="" && [string map {" " ""} [.bframe.reponse get]] != ""} {
    set tableaumots($str) [string map {\" \042} [.bframe.reponse get]]
    } else {
    catch {unset tableaumots($str)}
    }
}

proc tagueindice {} {
global sysFont tableauindices str
    if {$str !="" && [string map {" " ""} [.bframe.repindice get]] != ""} {
    set tableauindices($str) [string map {\" \\042} [.bframe.repindice get]]
    } else {
    catch {unset tableauindices($str)}
    }
}

proc lowlight {} {
variable marque 
variable substexte
global tableauindices tableaumots
    if {$marque=="grey"} {
    if {[catch {set str [.text get sel.first sel.last]}] != 1} {
    catch {unset tableauindices($str)}
    catch {unset tableaumots($str)}
    catch {
    destroy .bframe.reponse
    destroy .bframe.consigne
    destroy .bframe.indice
    destroy .bframe.repindice
    destroy .bframe.checksubst
    label .bframe.consigne -text [mc {Texte a corriger}]
    grid .bframe.consigne -row 0 -column 0
    checkbutton .bframe.checksubst -text [mc {Substituer au texte}] -variable substexte -relief flat -activebackground grey
    grid .bframe.checksubst -row 0 -column 1
    }

    }
    }
    if {$marque!="rien"} {
    catch {.text tag remove $marque sel.first sel.last}
    .text tag configure $marque -background $marque
    }
}

proc highlight {} {
global sysFont tableaumots str tableauindices
variable marque
variable substexte
    if {$marque!="rien"} {
    catch {.text tag add $marque sel.first sel.last}
    .text tag configure $marque -background $marque

        if {$marque=="grey"} {
            if {[catch {set str [.text get sel.first sel.last]}]} {
            catch {
		destroy .bframe.reponse
		destroy .bframe.consigne
		destroy .bframe.indice
		destroy .bframe.repindice
            destroy .bframe.checksubst
		}
    		label .bframe.consigne -text [mc {Texte a corriger}]
    		grid .bframe.consigne -row 0 -column 0
    		checkbutton .bframe.checksubst -text [mc {Substituer au texte}] -variable substexte -relief flat -activebackground grey
    		grid .bframe.checksubst -row 0 -column 1
            return
            }
            catch {
		destroy .bframe.reponse
		destroy .bframe.consigne
		destroy .bframe.indice
		destroy .bframe.repindice
            destroy .bframe.checksubst
		}
	label .bframe.consigne -text [mc {Mot de remplacement}]
	grid .bframe.consigne -row 0 -column 0
	entry .bframe.reponse
	grid .bframe.reponse -row 0 -column 1
	bind .bframe.reponse <KeyRelease> "tague"
	.bframe.reponse delete 0 end
	label .bframe.indice -text [mc {Indice}]
	grid .bframe.indice -row 0 -column 2
	entry .bframe.repindice
	grid .bframe.repindice -row 0 -column 3
	bind .bframe.repindice <KeyRelease> "tagueindice"
	.bframe.repindice delete 0 end
	set str [.text get sel.first sel.last]
	catch {.bframe.repindice insert end $tableauindices($str)}
	catch {.bframe.reponse insert end $tableaumots($str)}
        }

        if {$marque=="purple"} {
            if {[catch {set str [.text get sel.first sel.last]}]} {
            destroy .bframe.reponse
            destroy .bframe.consigne
            label .bframe.consigne -text [mc {Phrases incompletes}]
            grid .bframe.consigne -row 0 -column 0
            return
            }
             catch {
            destroy .bframe.reponse
            destroy .bframe.consigne
            label .bframe.consigne -text "Indice"
            grid .bframe.consigne -row 0 -column 0
            entry .bframe.reponse 
            grid .bframe.reponse -row 0 -column 1
            bind .bframe.reponse <KeyRelease> "tagueindice"
            .bframe.reponse delete 0 end
            set str [.text get sel.first sel.last]
            .bframe.reponse insert end $tableauindices($str)
            }
        }
   

    }
}











