#!/bin/sh
#menus.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $$$
#  Author  : davidlucardi@aol.com
#  Modifier: 
#  Date    : 
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     David Lucardi
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 
# 
#  *************************************************************************



global sysFont types oldmarque listexo
variable substexte
set substexte 1


set types {
    {{Fichiers texte, aller} {.txt .alr}}
}
set oldmarque "rien"


#t est un objet text
#w le nom a donnner au menu-frame
#p le nom de la toplevel parente
proc menu_frame {w t} {

    menubutton $w.file -text [mc {Fichier}] -menu $w.file.m -pady 7
    menubutton $w.edit -text [mc {Edition}] -menu $w.edit.m -pady 7
    menubutton $w.marquer -text [mc {Marquer pour}] -menu $w.marquer.m -pady 7
    bind .menu.marquer <1> "updatemenus"

#le menu fichier
    menu $w.file.m -background white -tearoff 0
    $w.file.m add command -label [mc {Ouvrir}] -command "charge $t none"
    $w.file.m add command -label [mc {Enregistrer}] -command "sauve $t"
    $w.file.m add separator
    $w.file.m add command -label [mc {Quitter}] -command "destroy ."
     
   
#le menu d'dition
    menu $w.edit.m -background white -tearoff 0
    $w.edit.m add command -label [mc {Copier (Ctrl-c)}] -command "tk_textCopy $t"
    $w.edit.m add command -label [mc {Couper (Ctrl-x)}] -command "tk_textCut $t"
    $w.edit.m add command -label [mc {Coller (Ctrl-v)}] -command "tk_textPaste $t"
        
#le menu marquage
    menu $w.marquer.m -background white -tearoff 0 
    $w.marquer.m add radio -label [mc {Closure}] -variable marque -value green -background green -command "coloremarque $t"
    $w.marquer.m add radio -label [mc {Reconstitution}] -variable marque -value blue -background blue -command "coloremarque $t"
    $w.marquer.m add radio -label [mc {Phrases melangees}] -variable marque -value pink -background pink -command "coloremarque $t"
    $w.marquer.m add radio -label [mc {Mots melanges}] -variable marque -value orange -background orange -command "coloremarque $t"
    $w.marquer.m add radio -label [mc {Texte a corriger}] -variable marque -value grey -background grey -command "coloremarque $t"
    $w.marquer.m add radio -label [mc {Phrases sans espaces}] -variable marque -value yellow -background yellow -command "coloremarque $t"
    #$w.marquer.m add radio -label [mc {Phrases incompletes}] -variable marque -value purple -background purple -command "coloremarque $t"
    $w.marquer.m add radio -label [mc {Exercice supplementaire 1}] -variable marque -value bisque1 -background bisque1 -command "coloremarque $t"
    $w.marquer.m add radio -label [mc {Exercice supplementaire 2}] -variable marque -value bisque2 -background bisque2 -command "coloremarque $t"
    $w.marquer.m add radio -label [mc {Exercice supplementaire 3}] -variable marque -value bisque3 -background bisque3 -command "coloremarque $t"
    $w.marquer.m add radio -label [mc {Exercice supplementaire 4}] -variable marque -value bisque4 -background bisque4 -command "coloremarque $t"
    $w.marquer.m add radio -label [mc {Rien}] -variable marque -value rien -background white -command "coloremarque $t"
    pack $w.file -side left
    pack $w.edit -side left
    pack $w.marquer -side left
    $w.marquer.m invoke 10
    return $w
}



proc coloremarque {t} {
variable marque 
variable sel1
variable substexte
global sysFont listexo oldmarque
if {[string match bisque* $oldmarque]== 1} {
set listexo [lreplace $listexo [expr [string index $oldmarque end] -1] [expr [string index $oldmarque end] -1] bisque[string index $oldmarque end]\040\173[string map {\" ""} [.bframe.entitre get]]\175\040\173[string map {\" ""} [.bframe.enfaire get]]\175\040$sel1]
}
catch {destroy .bframe}
frame .bframe -height 40
pack .bframe -side bottom -fill both
label .bframe.consigne
grid .bframe.consigne -row 0 -column 0 -columnspan 3

###############bidouillage pour contourner ce qui parat tre un bogue tcl/tk
set texte [$t get 1.0 "end - 1 chars"]
regsub -all \" $texte \\\" texte
append tmp "\$t insert end \"$texte\"\n"
    foreach tag [$t tag names] {
        if {[$t tag ranges $tag] != ""} {
	  append tmp "\$t tag add $tag [$t tag ranges $tag]\n"
	  }
    }
    foreach tg {green blue pink orange grey yellow purple bisque1 bisque2 bisque3 bisque4} {
    $t tag delete $tg
    }
$t delete 0.0 end
eval $tmp
######################fin bidouillage
if {$marque == "grey"} {
   checkbutton .bframe.checksubst -text [mc {Substituer au texte}] -variable substexte -relief flat -activebackground grey
   grid .bframe.checksubst -row 0 -column 3
   }

if {$marque != "rien"} {
.text tag configure $marque -background $marque
}
.bframe.consigne configure -text ""

if {[string match bisque* $marque]== 1} {
grid .bframe.consigne -row 0 -column 0 
label .bframe.titre -text [mc {Titre de l'exercice}]
grid .bframe.titre -row 1 -column 0 -sticky w -padx 1c
entry .bframe.entitre 
grid .bframe.entitre -row 2 -column 0 -sticky w -padx 1c
label .bframe.faire -text [mc {Consigne}]
grid .bframe.faire -row 1 -column 1 -sticky w
entry .bframe.enfaire -width 40
grid .bframe.enfaire -row 2 -column 1 -sticky w 
label .bframe.men1 -text [mc {Type de l'exercice}]
grid .bframe.men1 -row 0 -column 2 -sticky w -padx 1c
radiobutton .bframe.sel1 -text [mc {Reconnaitre}] -variable sel1 -relief flat -value 1
grid .bframe.sel1 -row 1 -column 2 -sticky w -padx 1c
radiobutton .bframe.sel2 -text [mc {Completer}] -variable sel1 -relief flat -value 2
grid .bframe.sel2 -row 2 -column 2 -sticky w -padx 1c
}

           switch $marque {
                green {
.bframe.consigne configure -text [mc {Closure}]
                }
                blue  {
.bframe.consigne configure -text [mc {Reconstitution}]
                }
                pink {
.bframe.consigne configure -text [mc {Phrases melangees}]
                }
                orange {
.bframe.consigne configure -text [mc {Mots melanges}]                }
                grey {
.bframe.consigne configure -text [mc {Texte a corriger}]

                }
                yellow {
.bframe.consigne configure -text [mc {Phrases sans espaces}]
                }
                purple {
.bframe.consigne configure -text [mc {Phrases incompletes}]
                }
                bisque1 {
.bframe.consigne configure -text [mc {Exercice supplementaire 1}]
.bframe.entitre insert end [lindex [lindex $listexo 0] 1]
.bframe.enfaire insert end [lindex [lindex $listexo 0] 2]
.bframe.sel[lindex [lindex $listexo 0] 3] select


                }
                bisque2 {
.bframe.consigne configure -text [mc {Exercice supplementaire 2}]
.bframe.entitre insert end [lindex [lindex $listexo 1] 1]
.bframe.enfaire insert end [lindex [lindex $listexo 1] 2]
.bframe.sel[lindex [lindex $listexo 1] 3] select
                }
                bisque3 {
.bframe.consigne configure -text [mc {Exercice supplementaire 3}]
.bframe.entitre insert end [lindex [lindex $listexo 2] 1]
.bframe.enfaire insert end [lindex [lindex $listexo 2] 2]
.bframe.sel[lindex [lindex $listexo 2] 3] select

                }
                bisque4 {
.bframe.consigne configure -text [mc {Exercice supplementaire 4}]
.bframe.entitre insert end [lindex [lindex $listexo 3] 1]
.bframe.enfaire insert end [lindex [lindex $listexo 3] 2]
.bframe.sel[lindex [lindex $listexo 3] 3] select
                }

            }
set oldmarque $marque
}


proc charge {t fil} {
global sysFont types tableaumots tableauindices listexo categorie Home
variable substexte
if {$fil == "none" || $fil == "" || $fil ==[mc {Aucun}]} {
wm iconify .
set file [tk_getOpenFile -initialdir $Home -filetypes $types]
wm deiconify .

} else {
set file $fil
}
    if {$file != ""} {
    $t delete 1.0 end
        if [string match *.alr $file] {
	  source $file
        set auto 1
	  } else {
	  set f [open $file]
	      while {![eof $f]} {
	      $t insert end [read $f 10000]
	      }
        set auto 0
        }
    wm title [winfo toplevel $t] "$file"
    set categorie $file

    } else {
    exit
    }
return $auto
}

proc sauve {t} {
global sysFont basedir tableaumots tableauindices listexo Home
variable sel1
variable marque
variable substexte
if {[string match bisque* $marque]== 1} {
set listexo [lreplace $listexo [expr [string index $marque end] -1] [expr [string index $marque end] -1] bisque[string index $marque end]\040\173[string map {\" ""} [.bframe.entitre get]]\175\040\173[string map {\" ""} [.bframe.enfaire get]]\175\040$sel1]
}

set types {    {{Fichiers aller}            {.alr}        }}
set ext .alr
catch {set name [tk_getSaveFile -filetypes $types -initialdir $Home]}
    if {$name != ""} {
        if  {[string match -nocase *.alr $name]==0} {
        set name $name$ext
        }
    set texte [$t get 1.0 "end - 1 chars"]
    regsub -all \" $texte \\\" texte
    append tmp "\$t insert end \"$texte\"\n"
        foreach tag [$t tag names] {
            if {[$t tag ranges $tag] != ""} {
	      append tmp "\$t tag add $tag [$t tag ranges $tag]\n"
	      }
        }
    catch {
    set list [array get tableaumots]
    for {set i 0} {$i < [llength $list]} {incr i 2} { 
    append tmp "set tableaumots([string map {" " \\040 \042 \\042 \n \\n} [lindex $list $i]]) [string map {" " \\040 \042 \\042 \n \\n} [lindex $list [expr $i + 1]]]\n"

    }
    }
    catch {
    set list [array get tableauindices]
    for {set i 0} {$i < [llength $list]} {incr i 2} {  
    append tmp "set tableauindices([string map {" " \\040 \042 \\042 \n \\n} [lindex $list $i]]) [string map {" " \\040 \042 \\042 \n \\n} [lindex $list [expr $i + 1]]]\n"
    }
    }
    append tmp "set substexte $substexte \n"
    append tmp "set listexo [lreplace listexo 0 end $listexo]\n"
    set f [open $name "w"]  
    puts $f $tmp
    close $f
    }
}


proc updatemenus {} {
global sysFont listexo
if {[lindex [lindex $listexo 0] 1] !="Exercice 1"} {
.menu.marquer.m entryconfigure 6 -label [lindex [lindex $listexo 0] 1]
} else {
.bframe.consigne configure -text [mc {Exercice supplementaire 1}]
}
if {[lindex [lindex $listexo 1] 1] !="Exercice 2"} {
.menu.marquer.m entryconfigure 7 -label [lindex [lindex $listexo 1] 1]
} else {
.bframe.consigne configure -text [mc {Exercice supplementaire 2}]
}
if {[lindex [lindex $listexo 2] 1] !="Exercice 3"} {
.menu.marquer.m entryconfigure 8 -label [lindex [lindex $listexo 2] 1]
} else {
.bframe.consigne configure -text [mc {Exercice supplementaire 3}]
}
if {[lindex [lindex $listexo 3] 1] !="Exercice 4"} {
.menu.marquer.m entryconfigure 9 -label [lindex [lindex $listexo 3] 1]
} else {
.bframe.consigne configure -text [mc {Exercice supplementaire 4}]
}

}







