#!/bin/sh
#reconnaitre.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $$$
#  Author  : davidlucardi@aol.com
#  Modifier: 
#  Date    : 
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     David Lucardi
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 
# 
#  *************************************************************************

source menus.tcl
source parser.tcl
source eval.tcl
source msg.tcl
source fonts.tcl
source path.tcl

#variables
#nbreu : nombre d'items effectues
#essais : total des essais effectues
#auto : flag de detection du mode de fonctionnement 
#couleur : couleur associe  l'exercice
#aide : prcise  quel moment doit intervenir l'aide
#longchamp : prcise si les champs sont de longueur variable

global sysFont nbreu essais auto couleur aide longchamp xcol ycol listevariable categorie startdirect user Homeconf
set couleur $argv
set nbreu 0
set essais 0
set auto 0
set aide 2
set longchamp 1
set xcol 0
set ycol 0
set listevariable 1
set categorie ""
set startdirect 1

set ident $tcl_platform(user)
set plateforme $tcl_platform(platform)
initlog $plateforme $ident
inithome

#interface
. configure -background black -width 640 -height 480
wm geometry . +0+0


#wm title . Bilan\040[lindex [split [lindex [split $file /] end] .] 0]
frame .menu -height 40
pack .menu -side bottom -fill both
button .menu.b1 -text [mc {Commencer}] -command "main .text"
pack .menu.b1 -side right


text .text -yscrollcommand ".scroll set" -setgrid true -width 55 -height 17 -wrap word -background white -font $sysFont(l)
scrollbar .scroll -command ".text yview"
pack .scroll -side right -fill y
pack .text -expand yes -fill both
#recupration des options de reglages
catch {
set f [open [file join $Homeconf reglages aller.conf] "r"]
set categorie [gets $f]
close $f
}

catch {
set f [open [file join $Homeconf reglages ponctuation1.conf] "r"]
set aller [gets $f]
close $f
set aide [lindex $aller 0]
set longchamp [lindex $aller 1]
set listevariable [lindex $aller 2]
set startdirect [lindex $aller 4]
}

#chargement du texte avec dtection du mode
#set auto [charge .text $categorie]
set t .text
$t delete 1.0 end
source $categorie
focus .text
.text configure -state disabled

catch {
set f [open [file join $Home reglages [lindex [lindex $listexo [expr [string index $couleur end] -1]] 0].conf] "r"]
set aller [gets $f]
close $f
set aide [lindex $aller 0]
set longchamp [lindex $aller 1]
set listevariable [lindex $aller 2]
set startdirect [lindex $aller 4]
}


label .menu.consigne -text [lindex [lindex $listexo [expr [string index $couleur end] -1]] 2]
pack .menu.consigne -side top


proc main {t} {
#liste principale de phrases contenant les mots sans ponctuation, liste de mots  cacher
#listessai : tableau pour tenir  jour les essais sur chaque mot
#texte : le texte initial
#longmot : longueur maximale des champs de texte

global sysFont plist listemotscaches listessai texte nbmotscaches auto longchamp longmot
set nbmotscaches 0

button .menu.b2 -text "Correction" -command "abandon $t"
pack .menu.b2 -side left


catch {destroy .menu.b1}
button .menu.b1 -text [mc {Fin}] -command "destroy ."
pack .menu.b1 -side right
bind .menu  <Destroy> "fin"
$t configure -state normal

    pauto $t
    
    $t configure -state disabled -selectbackground white -selectforeground black


}

proc pauto {t} {


#########################################################""


global sysFont plist listemotscaches listessai texte nbmotscaches couleur aide longchamp longmot listeaide
set nbmotscaches 0
set listemots {}
set listemotscaches {}

# Construction de la liste des mots  cacher,  partir des tags
set liste [$t tag ranges $couleur]
    for {set i 0} {$i < [llength $liste]} {incr i 2} {
    incr nbmotscaches
    set str [$t get [lindex $liste $i] [lindex $liste [expr $i + 1]]]
    regsub -all \"+ $str "" str
    lappend listemotscaches $str        
    }

 set longmot 0
        foreach mot $listemotscaches {
            if {$longmot < [string length $mot]} {
            set longmot  [string length $mot]
            }
        }

    if {$nbmotscaches == 0} {
    set answer [tk_messageBox -message [mc {Erreur de traitement ou texte trop court.}] -type ok -icon info] 
    exit
    }


#On marque le texte pour substituer les mots  cacher par des champs de texte
    for {set i 0} {$i < [llength $liste]} {incr i 1} {
    $t mark set cur$i [lindex $liste $i]
    }
# On opre la substitution
    for {set i 0} {$i < [llength $listemotscaches]} {incr i 1} {           
    $t tag add ent$i cur[expr $i*2] cur[expr ($i*2) +1]
    
    set listessai($i) 0
    }

set listeaide $listemotscaches

$t tag add text 1.0 end
$t tag bind text <ButtonRelease-1> "hit $t"
$t tag configure rouge -background red
$t tag configure jaune -background yellow

}


proc hit {t} {
global sysFont longchamp longmot listemotscaches essais motfaux nbreu aide listeaide listevariable

$t configure -state normal
set ind [lsearch [$t tag names current] "ent*"] 
    if {$ind != -1} {
    set nom [lindex [$t tag names current] $ind]
    set num [string map {ent ""} $nom]
    set motfaux [$t get $nom.first $nom.last]
    #$t delete $nom.first $nom.last
    $t tag add jaune $nom.first $nom.last

        foreach tag [$t tag names current] {
        if {$tag != "jaune"} {
        catch {$t tag remove $tag $nom.first $nom.last}
        }
        }
    incr essais
    incr nbreu
    catch {destroy .menu.lab}
    label .menu.lab -text [format [mc {%1$s mots trouves sur %2$s.}] $nbreu [llength $listemotscaches]]
    pack .menu.lab

    testefin $nbreu $essais

    return
    } else {
    $t tag add rouge current
    incr essais
    }
$t configure -state disabled

}


proc testefin {nbreu essais} {
global sysFont listemotscaches user categorie listexo couleur
    if {$nbreu >= [llength $listemotscaches]} {
    catch {destroy .menu.lab}
    set str0 [mc {Exercice termine en }]
    set str2 [format [mc {%1$s essais pour %2$s mots.}] $essais $nbreu]
    set str1 [lindex [lindex $listexo [expr [string index $couleur end] -1]] 1]
    #enregistreval $str1 $categorie $str2 $user
    label .menu.lab -text $str0$str2
    pack .menu.lab
    .text tag remove text 1.0 end
    bell
        }
}



if {$startdirect == 0 } {
main .text
}

proc abandon {t} {
global sysFont plist listemotscaches listessai texte nbmotscaches auto longchamp longmot
global sysFont longchamp longmot listemotscaches essais motfaux
set cur 0.0
$t configure -state normal
catch {destroy .menu.b2}
catch {destroy .menu.lab}

set listtag [$t tag names]
    foreach tg $listtag {
catch {
       set ind [lsearch $tg "ent*"]
       if {$ind != -1} {

          set nom $tg
          set num [string map {ent ""} $nom]
          set motfaux [$t get $nom.first $nom.last]
          #set cur [$t search $motfaux $cur end]
          set cur [$t index $nom.first]

          $t delete $nom.first $nom.last
          $t insert $cur [lindex $listemotscaches $num]
          $t tag add violet $cur "$cur + [string length [lindex $listemotscaches $num]] char"


        $t tag bind text <ButtonRelease-1> {}

       }
}
}
$t tag configure violet -background pink

$t configure -state disabled

}

proc fin {} {
global sysFont categorie user essais listemotscaches nbreu listexo couleur

    set str1 [lindex [lindex $listexo [expr [string index $couleur end] -1]] 1]


    set str2 [format [mc {%1$s essais pour %2$s mots sur %3$s.}] $essais $nbreu [llength $listemotscaches]]


    enregistreval $str1 \173$categorie\175 $str2 $user

exit
}



